var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import { jsx as _jsx } from "react/jsx-runtime";
import { createContext, useContext } from 'react';
import { ProviderValueError, InvalidContextUsage } from './errors';
var useContextValue = function (context) {
    var value = useContext(context);
    if (value === undefined) {
        throw new InvalidContextUsage();
    }
    return value;
};
var createProvider = function (_a, context) {
    var children = _a.children, value = _a.value;
    var ContextProvider = context.Provider;
    if (value === undefined) {
        throw new ProviderValueError();
    }
    return _jsx(ContextProvider, __assign({ value: value }, { children: children }), void 0);
};
export var contextFactory = function () {
    var ctx = createContext(undefined);
    var useContextData = function () { return useContextValue(ctx); };
    var Provider = function (props) { return createProvider(props, ctx); };
    return [Provider, useContextData];
};
//# sourceMappingURL=contextFactory.js.map