var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import { jsx as _jsx } from "react/jsx-runtime";
import { useState } from 'react';
import { contextFactory } from './contextFactory';
export var updatableContextFactory = function (initialValue) {
    var _a = contextFactory(), ValueProvider = _a[0], useContextValue = _a[1];
    var _b = contextFactory(), DispatchProvider = _b[0], useDispatch = _b[1];
    var Provider = function (_a) {
        var children = _a.children;
        var _b = useState(initialValue), state = _b[0], update = _b[1];
        return (_jsx(DispatchProvider, __assign({ value: update }, { children: _jsx(ValueProvider, __assign({ value: state }, { children: children }), void 0) }), void 0));
    };
    return [Provider, useContextValue, useDispatch];
};
//# sourceMappingURL=updatableContextFactory.js.map